<?php
/**
 * @package LiveUpdate
 * @copyright Copyright ©2011 Nicholas K. Dionysopoulos / AkeebaBackup.com
 * @license GNU LGPLv3 or later <http://www.gnu.org/copyleft/lesser.html>
 */

defined('_JEXEC') or die();

/**
 * Configuration class for your extension's updates. Override to your liking.
 */
class LiveUpdateConfig extends LiveUpdateAbstractConfig
{
	var $_extensionName			= 'com_ats';
	var $_versionStrategy		= 'different';
	var $_storageAdapter		= 'component';
	var $_storageConfig			= array(
		'extensionName'	=> 'com_ats',
		'key'			=> 'liveupdate'
	);

	function __construct()
	{
		JLoader::import('joomla.filesystem.file');

		// Load the component parameters, not using JComponentHelper to avoid conflicts ;)
		JLoader::import('joomla.html.parameter');
		JLoader::import('joomla.application.component.helper');
		$db = JFactory::getDbo();
		$sql = $db->getQuery(true)
			->select($db->qn('params'))
			->from($db->qn('#__extensions'))
			->where($db->qn('type').' = '.$db->q('component'))
			->where($db->qn('element').' = '.$db->q('com_ats'));
		$db->setQuery($sql);
		$rawparams = $db->loadResult();
		$params = new JRegistry();
		if(version_compare(JVERSION, '3.0', 'ge')) {
			$params->loadString($rawparams, 'JSON');
		} else {
			$params->loadJSON($rawparams);
		}

		$isPro = 0;
		if(defined('ATS_PRO'))
		{
			$isPro = ATS_PRO;
		}

		if ($isPro)
		{
			$this->_updateURL = 'http://cdn.akeebabackup.com/updates/ats.ini';
		}
		else
		{
			$this->_updateURL = 'http://cdn.akeebabackup.com/updates/atscore.ini';
		}
		$this->_extensionTitle = 'Akeeba Ticket System ' . ($isPro ? 'Core' : 'Professional');

		// Set up the version strategy
		if(defined('ATS_VERSION')) {
			if(in_array(substr(ATS_VERSION, 0, 3), array('svn','dev','rev'))) {
				// Dev releases use the "newest" (date comparison) strategy.
				$this->_versionStrategy = 'newest';
			} else {
				// In all other cases, we check for a different version
				$this->_versionStrategy = 'different';
			}
		}

		// Get the minimum stability level for updates
		$this->_minStability = $params->get('minstability', 'alpha');

		//Force authorization
		$this->_requiresAuthorization = ($isPro ? 1 : 0);

		// Should I use our private CA store?
		if(@file_exists(dirname(__FILE__).'/../assets/cacert.pem')) {
			$this->_cacerts = dirname(__FILE__).'/../assets/cacert.pem';
		}

		parent::__construct();
	}
}